#import <appkit/View.h>

#define NSTARS (200)
#define STARSPERIT (100)

typedef struct STAR {
	float theta;	// angle
	float distance;
	float delta;	// change in distance
	float ddelta;	// change in delta, a constant multiplier
	int changemode;
	float changepoint[6];
	
	NXRect draw;
	NXRect erase;
	
	} STAR;

@interface Space2View:View
{
	STAR stars[NSTARS];
	int nstars;
	int radius;			// min radius of this view

	NXRect b[NSTARS];
	NXRect w[NSTARS];
}

- convertToXY:(STAR *)p;
- oneStep;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- addStar;
- replaceStarAt:(int)index;
- setRadius;
@end

