/*
	file:
		FireflyView.h
	
	history:
		1993-06-06, andrew abernathy
			 created
		1993-07-04, andrew abernathy
			 added configurability
*/


#import <appkit/appkit.h>
#import "Thinker.h"


@interface	FireflyView:View
	{
	NXPoint *	fireflies;		// turns out, this is an array of firefly positions
	NXColor		fireflyColor;		// what color are these fireflies?
	id		fireflyColorWell;	// this is the color well for setting the fireflies color
	int		fireflyCount;		// how many fireflies?
	id		fireflyCountField;	// this is the field for setting the number of fireflies
	BOOL		fireflyCountChanged;	// firefly count changed flag
	NXColor		backgroundColor;	// what color is the background?
	id		backgroundColorWell;	// this is the background color well in our inspector
	int		backgroundColorChanged;	// background color changed flag
	id		sharedInspectorPanel;	// our inspector
	BOOL		isBoring;		// are we a boring module?
	id		isBoringSwitch;		// this is the switch for setting whether or not we're boring
	}


// these are things needed for general operation

+ initialize;
- inspectorInstalled;
- oneStep;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- initFrame:(const NXRect *)frameRect;
- inspector:sender;
- (BOOL)isBoringScreenSaver;


// these are view-specific methods

- (NXPoint *)generateFireflies:(int)numFireflies;
- setBackgroundColor:sender;
- setIsBoring:sender;
- setFireflyColor:sender;
- setFireflyCount:sender;
- openReadme:sender;
- resetSettings:sender;

@end
