/* IconMosaicView.h -- copyright 1993 by Christopher Lane */

#import <appkit/View.h>
#import <mach/cthreads.h>

@interface IconMosaicView : View
{
	id images;
	id defaults;
	
	id field;
	id inspector;
	id density;
	
	mutex_t lock;
	cthread_t thread;
	condition_t condition;

	NXSize maximumSize;
	unsigned int maximumBytes, maximumImages;
}

- initFrame:(NXRect *) frameRect;
- drawSelf:(const NXRect *) rects :(int) rectCount;
- didLockFocus;
- free;

- oneStep;
- inspector:sender;
- inspectorInstalled;
- (BOOL) useBufferedWindow;
- (const char *) windowTitle;

- setDefault:sender;
- setDensity:anObject;

- (BOOL) loadFromStream:(NXStream *) stream;
- (BOOL) member:(const char *) item ofSet:(const char *) set;

- loadImagesFromDirectory:(const char *) directory;
- loadImagesFromSegment:(const char *) filename;

@end
