//This code is the work of Booker C. Bense (benseb@next.sdsc.edu)
// You are free to change/distribute this code provided this notice
// remains intact in all versions. 

#import "BackView.h"
#import <math.h> 


#ifndef M_PI
#define PI 3.1415926
#else
#define PI M_PI
#endif

#define TWO_PI (PI*2.0)


#define R 28.0
#define S 10.0 
#define B 2.666666666
#define delta_T (0.01 * (25.0 / R ) )
#define Xmin -25.0
#define Ymin -30.0
#define Zmin 0.0
#define Yrange 60.0
#define Xrange 50.0 
#define Zrange 60.0

#define CHASERS  20
#define CHASELEN 40
#define NUMPOINTS ((CHASERS+1)*CHASELEN)
#define NTHETA 400.0
#define RED 0
#define GREEN 1
#define BLUE 2

@interface LorenzRotateView:BackView
//@interface LorenzRotateView:View
{
  int p,n;
  int points[CHASERS];
  

  double X[NUMPOINTS],Y[NUMPOINTS],Z[NUMPOINTS];

  NXRect curBounds; 
  NXRect pixels[NUMPOINTS]; 
  NXRect *pixelpoint; 
  float urx,ury, midx, midy,cos_arg,theta;
  float xc[NUMPOINTS],yc[NUMPOINTS]; 
  double xdot,ydot,zdot; 
  int red_shift,blue_shift;
  float cl_clut[CHASERS],twobit_clut[CHASERS]; 
  float *clut; 
}

- oneStep;
- newSize;
@end

