/*
 * Module:
 *	ModernArt
 *
 * Author:
 *	Doug "Kareth" McClure
 *	asd@cc.purdue.edu
 *	XASD@PURCCVM.BITNET
 *
 * Version: 1.0
*/

#import "ModernArtView.h"
#import "Thinker.h"
#import "ModernArtWraps.h"
#import <appkit/NXImage.h>
#import <appkit/Window.h>
#import <appkit/Panel.h>                // for NXRunAlertPanel()
#import <dpsclient/wraps.h>
#import <libc.h>
#import <math.h>

#define TIME_DELAY	1000

@implementation ModernArtView

- oneStep
{
  static int count = 0;

  if ( count++ == 0 )
    {
      PSsendint(ySize);
      PSsendint(xSize);
      psModernArtRun();
    }
  else if ( count > TIME_DELAY )
    {
      count = 0;
    }

  return self;
}


- initFrame:(NXRect *)frameRect
{
  [super initFrame:frameRect];
  [self newSize];

  return self;
}


- sizeTo:(NXCoord)width :(NXCoord)height
{
  [super sizeTo:width :height];
  [self newSize];

  return self;
}


- newSize
{
  xSize = bounds.size.width;
  ySize = bounds.size.height;

  return self;
}

@end
