#import <appkit/View.h>

#define RIGHT 0
#define LEFT 1
#define UP 2
#define DOWN 3

#define HORSIZE (horCount * (vertCount + 1))
#define VERTSIZE ((horCount + 1) * vertCount)

#define HOREDGE(I,J) (horEdges[(vertCount + 1)*(I) + (J)])
#define VERTEDGE(I,J) (vertEdges[vertCount*(I) + (J)])

typedef struct {
	int row, col;
} intPair;

typedef struct {
	intPair tailEdge;
	short tailOrient;
	intPair	headEdge; /* head edge */
	short headOrient; /* orientation of headEdge */
	int maxLength, currentLength; 
	BOOL dead; /* YES if head edge currently can't progress */
} trail;

typedef struct {
	float red, blue, green;
} rgbColor;

@interface NickSpaceView:View
{
	id spaceControl;
	id countControl;
	id lengthControl;
	id colorWell;
	id colorScrollers;
	id addRemoveButtons;
	id numColorsField;

	int horCount, vertCount;
	char *horEdges, *vertEdges;
	
	int lastLevel;
	BOOL firstTime;
	
	id inspector;
	
	id image;	
	
	float tcRatio;
	short trailCount;
	trail *trails;
	
	short spacing;
	
	float tlRatio;
	int maxTrailLen;
	int minTrailLen;
	
	
	int numColors;
	int currColor;
	rgbColor *colors;
		
}

- calcNext;
- oneStep;
- sizeTo:(NXCoord)width :(NXCoord)height;
- initFrame:(NXRect *)frameRect;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- newSize:(BOOL)freeOld;
- startTrails;
- inspector:sender;

- updateCurrColor:sender;
- scrollColor:sender;
- addColor:sender;
- removeColor:sender;

- getSpacingFrom:sender;
- getNumberFrom:sender;
- getMaxLenFrom:sender;

@end
