//
// DigitalClock
//
// Module for BackSpace.app
// rev 1.2 11 Dec 1991
// rev 1.3 20 Aug 1992
//
// Matt Pharr- pharr@cs.yale.edu
// NeXTMail Welcome
//

#import <appkit/appkit.h>
#import "Thinker.h"

@interface DigitalClockView:View
{
    NXPoint currentLocation;    /* current location of the bitmap */
    NXPoint moveVector;         /* not a point, but a vector that describes how
                                   the bitmap is moving... */

    char theTime[14];           /* the current time, in string form "hh:mm:ss" */
    char lastTime[14];          /* the time the last time oneStep was called */
	
    NXSize currentSize;         /* the size of the bitmap */
    id currentImage;            /* the bitmap itself that holds the drawing of 
                                   the time  */
    id theFont;
    float currR, currG, currB;
    id sharedInspectorPanel;
    float clockSize;
    float bounceMultiplier;
    BOOL militaryTime;
    BOOL didShorten;            /* set to YES when a time like 01:22:34 PM is
                                 * shortented to 1:22:34 PM. This way, the fact
                                 * that we allocated some now unused real estate
                                 * in the bitmap doesn't matter, due to some
                                 * minor kludges in the fixPosition and
                                 * bounceIfNeeded methods.
                                 */
    BOOL isNew;
    id speedSlider;
    id sizeSlider;
    id militarySwitch;
}

-oneStep;
-drawSelf:(const NXRect *)rects :(int)rectCount;
-initFrame:(const NXRect *)frameRect;
-setClockSize:sender;
-setBounceMultiplier:sender;
-setMilitaryTime:sender;
-inspector:sender;

@end
