#import <dpsclient/event.h>

// Constants
#define MAXSPIRALS	100
#define MINRADIUS 50
#define MAXRADIUS 300


@interface SpiralView:View
{
	float	minRadius;
	float	maxRadius;
	float	maxSpirals;

	int	numSpirals;
	float	x,y;			// coordinates of center of circle
	float	radius;			// radius of circle
	int	colorIndex;
	float	degree;			// degrees of circle to arc at
	int	degIterations;		// current # of degree iterations made
	int	degCircles;			// # loops around the circle
	float	maxDegree;			// # degrees around the circle
	float	maxCurrentRadius;	// largest radius of current circle

#ifdef IB
	id	inspectorPanel;
	id	minRadiusSlider;
	id	minRadiusField;
	id	maxRadiusSlider;
	id	maxRadiusField;
	id	maxSpiralsSlider;
	id	maxSpiralsField;
#else
	Box		*inspectorPanel;
	Slider		*minRadiusSlider;
	TextField	*minRadiusField;
	Slider		*maxRadiusSlider;
	TextField	*maxRadiusField;
	Slider		*maxSpiralsSlider;
	TextField	*maxSpiralsField;
#endif
}

- initFrame:(const NXRect *)frameRect;
- oneStep;
- (const char *)windowTitle;
- inspector:sender;
- sizeTo:(NXCoord)width :(NXCoord)height;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- (BOOL) useBufferedWindow;

- changeMinRadius:sender;
- changeMaxRadius:sender;
- changeMaxSpirals:sender;

- (void)loadDefaults;
- (void)saveDefaults;
- (void)constrainDefaults;

- startOver;
- newSpiral;

@end

