#import <appkit/appkit.h>
#import "CelestialCommon.h"
#import <sys/dir.h> //for getdirentries()
#include <pwd.h>

@interface TiffManager:Object
{


    const char		*moduleDir;
    Storage			*tiffStorage;
    char  			tiffDirectory[MAXPATHLEN + 1];


	List 			*localImageList;
	id				sourceImage;	
	NXImage			*buffer,*image;
	NXRect 			adjustedRect;
	NXSize 			adjustedSize;
	float 			maxImageSize;
	NXSize 			sourceImageSize;
	NXSize 			scaledImageSize;
	NXRect 			scaledImageRect;
	NXSize 			spinScaledImageSize;//square image for spinning object
	NXRect 			spinScaledImageRect;
	NXRect 			spinAdjustRect;	//if isSpin then new images are square
	NXPoint 		spinCenter;
	
	BOOL 			widthIsSmaller;
	int 			tiffStorageIndex;
	int 			animationIndex;
	int 			totalTiffCount;
	int				numberProcessed;
	int				 animFileIndex;
	int 			maxAnimFiles;
	float 			angle,angleInc,scaledDiagonal;	//for rotating image
}

- (BOOL)createTiffs;
- freeTiffs;
- buildTiffStorage;
- setTiffDirectory: (char *)directory;
- (int)searchDirectory;
- (Storage *)returnTiffStorage;  	//return
- setHomeDirFile:(char *)path;
- (BOOL)isOk:(char *)filename :(int *)isAnim :(int *)isMult :(int *)isSpin;
- (int)isAnimOk: (char *)dir :(char *)filename; 
- (BOOL)stringMatch:(char *)string1 : (char *)string2;
@end
