#import <appkit/appkit.h>
#import "Thinker.h"

// this code is copyright Darcy Brockbank, 1993
//
// You may freely reuse and distribute this code in any way shape or
// form, provided that this notice stays intact.
//
// darcy@hasc.ca, samurai@cs.mcgill.ca
//
// StefView was implemented out of WorldSpaceView and retains some of the
// movement properties...
//
// The code for WorldSpaceView was written by Sam Streeper at NeXT, I think,
// and there were two other contributors, but I can't find their names in the
// source for it.
//
// StefView is the common "Spotlight" screen saver you see on Macs and Windows
// all the time. This is just a quick hack, and can do with vast amounts of
// improvement I'm sure.
//
// If you do improve this thing, send me a copy!
//
// - darcy


typedef struct { float l,b,r,t;	} BRECT;

@interface StefView:View
{
	id buffer;
	id spot;
	id clearSpot;
	id sbuffer;
	float	xpos;
	float	ypos;
	BRECT old;
	NXPoint ballTo;
	NXPoint maxCoord;
	NXPoint redrawTo;
	NXRect redraw;
	NXSize oldSize;
	int framesPerSecond;
	int currentFrame;
	NXSize imageSize;
	BStimeval now, then;
	BStimeval nextRotationTime;
	id sharedInspectorPanel;
	
}

- oneStep;
- sizeTo:(NXCoord)width :(NXCoord)height;
- newViewSize;
- (const char *)windowTitle;

@end
