#import <appkit/View.h>
#import "Thinker.h"

typedef struct { float l,b,r,t; } BRECT;

#define DECREASING 0
#define INCREASING 1

char *basename(char *path, char *suffix);

@interface WorldSpaceView:View
{
    float   xpos;
    float   xspeed;
    float   ypos;
    float   yspeed;
    float   accel;
    int ballNum;
    int spinDir;
    int rebound;

    float viewHeight;
    float viewWidth;

    BRECT old;
    NXPoint ballTo;
    NXPoint redrawTo;
    NXRect redraw;
    NXSize oldSize;
	NXRect avoid;

    id balls;
	id buffer;

    int toggle;
    int reboundMode;
    float lastLaunchSpeed;

    BStimeval now, then;
    BStimeval nextRotationTime;

	id mySpaceView;
    id imageList;
    int numberOfFrames;
	int framesPerSecond;
}

- oneStep;
- initFrame:(NXRect *)frameRect;
- newSpeed;
- setAccel:(float)val;
- sizeTo:(NXCoord)width :(NXCoord)height; 
- drawSelf:(const NXRect *)rects :(int)rectCount;
- newViewSize;
- incrementBallNumber;
- (float) getRandomXspeed;
- (float) timeCorrectedXSpeed; 
- checkXspeed:(float *)speed;
- (const char *)windowTitle;
- didLockFocus;
@end
