
#import <appkit/appkit.h>
#import "BackView.h"
#import "Thinker.h"
#import "ModuleList.h"

struct thinkerDef {
	// Abstraction barriers?  we don't need no stinking abstraction barriers!
	@defs(Thinker)
};

struct layout_def {
	int num;
	NXRect *pos;
};


#define MAX_VIEWS 9

@interface MultiView:BackView
{
	// IB connections
	id	scrollView;
	id	matrix;
	id	inspectorPanel;
	id	otherInspector;
	id	layout;
	id	lay1;
	id	lay2;
	id	lay3;
	id	lay4;
	id	lay5;
	id	lay6;
	id	lay7;
	id	lay8;
	id	lay9;
	id	lay10;
	id	lay11;
	
	// other instance vars;
	id	thinker;
	id	views[MAX_VIEWS];
	id	modList;
	id	layouts[11];
	int currentLay;
	struct layout_def lay_defs[11];
	struct thinkerDef *pub;
	int num;
	List *sel_list;
}

- oneStep;
- (const char *)windowTitle;
- inspector:sender;
- (BOOL)useBufferedWindow;
- initFrame:(const NXRect *)frm;
- fillMatrix;
- select:sender;
- inspect:sender;
- addCellWithString:(const char *)str at:(int)row;
- viewFrom:sender;
- viewNamed:(const char *)name;
- objectNamed:(const char *)name;
- (int)cellNamed:(const char *)name;
- loadView:(const char *)name;
- layoutUp:sender;
- layoutDown:sender;
- initLayouts;
- allocLayout:(int)index;
- readDefaults;
- writeDefaults:sender;
- inspectorWillBeRemoved;
- setImage:image;

// these methods are actually methods implemented by the thinker
// some of the views rely on the thinker being the one controlling things.
// funny that huh?
// I didn't really have to prototype them since I import Thinker.h,
// but I figured that this would make things a little more complete.
- spaceInspector;
- commonImageInspector;
- nullInspector;
- boinkInspector;
- (const char *)moduleDirectory:(const char *)name;

//
// these methods are just handoffs to child views
//
// - setImage:image; // we'll ignore this one for now
- enteredScreenSaverMode;
- willExitScreenSaverMode;
@end


@interface Object (BSdelegates)
- didLockFocus;
@end